unit Data;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IBDatabase, Db, mtrServer, mtrCustomServers, mtrClient;

type
  TdmMain = class(TDataModule)
    mtrClient: TmtrClient;
    mtrIBServer: TmtrIBServer;
    IBDatabase: TIBDatabase;
    IBTransaction: TIBTransaction;
    procedure mtrClientPrintBand(const AMax, ACurrent: Integer;
      var AFinish: Boolean);
    procedure mtrClientAfterExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Connect(APath: string);
    procedure Disconnect;
    procedure ShowAbout;
  end;

var
  dmMain: TdmMain;

implementation

uses About, Progress;

{$R *.DFM}

{ TdmMain }

procedure TdmMain.Connect(APath: string);
begin
  IBDatabase.DatabaseName := APath + 'DBDEMOS.GDB';
  IBDatabase.Open;
  IBTransaction.StartTransaction;
end;

procedure TdmMain.Disconnect;
begin
  IBTransaction.Commit;
  IBDatabase.Close;
end;

procedure TdmMain.ShowAbout;
begin
  fmAbout.ShowModal;
end;

procedure TdmMain.mtrClientPrintBand(const AMax, ACurrent: Integer;
  var AFinish: Boolean);
begin
  with fmProgress do begin
    ProgressBar.Max := AMax;
    ProgressBar.Position := ACurrent;
    if not Visible then begin
      Show;
      SetFocus;
    end;
    Application.ProcessMessages;
    AFinish := Cancel;
    Cancel := false;
  end;
end;

procedure TdmMain.mtrClientAfterExecute(Sender: TObject);
begin
  if fmProgress.Visible then fmProgress.Close;
end;

end.
